
clc;
clear;
close all
warning off

% load Wind_hourly.csv % 7265
% raw_data = Wind_hourly'; %


load mgdata.dat %Mackey-Glass Chaotic Time Series 1201 stationary
raw_data = mgdata( 1:1201, 2)';
% load D:\data\timeseries\exchange_rate_of_australian_doll.csv  %314 
% raw_data = exchange_rate_of_australian_doll';
% load D:\data\timeseries\mean_daily_flow_cumecs_vatnsdals_copy.csv  %1095  
% raw_data = mean_daily_flow_cumecs_vatnsdals_copy';
% load Wind_10min.csv % 39195
% raw_data = Wind_10min'; %

solver= 'convex'; % '
% ---------------
[data1,PS]=mapminmax(raw_data,0,1);
data1=data1';   
 
data = data1(1:1*length(data1));
train = data1(1:0.8*length(data1));
test = data1( length(train)+1 : length(data) );

[test_row, test_line]=size(test);
[train_row, train_line]=size(train);
[data_row, data_line]=size(data);
data_rec=zeros(data_row, data_line);

num_interval = 5;
num_c = 3; % num. of nodes of the FCMs
r = 100;%

type=0;
defin_center=[0 0.5 1];%
weight_matrices = zeros(num_c,num_c, r);
membership = zeros(num_interval,num_c, r);

[U_ms,center]= fun_trimf(data',type,num_c,defin_center);
U = U_ms';
data_rec1 = fun_trim_rec(U,center);     
data_fcmrec_RMSE =fun_RMSE(data_rec1,data);    
disp(['RMSE error: ',num2str(data_fcmrec_RMSE)]);

iMax = train_row-num_interval;
rand_num = randperm(iMax,r);
for k=1:r % disjoint
    membership(:,:,k) = U( rand_num(k) : rand_num(k)+num_interval-1,: );
end


if strcmp( solver, 'convex')
    membership(membership<=0)=0.0001;
    membership(membership>=1)=0.9999;
end
% ---------
beta0 = 0.0;
lambda = 5; b = 0;
alpha0 =0.0;
W_cvx = zeros(num_c,num_c);
tic
if strcmp( solver, 'convex')
    for k=1:r
        U1= membership(:,:,k);
        X=U1(1:num_interval-1,:);
        Y=U1(2:num_interval,:);
        D=-(1/lambda)*log((1-Y)./Y);
        for i=1:num_c
            cvx_begin  quiet
            cvx_precision default
            variable Wx(num_c);
            minimize( norm(X*Wx - D(:,i),2))
            subject to
            norm(Wx, Inf) <= 1.0  %
            cvx_end
            W_cvx(:,i) = Wx;
        end
        weight_matrices(:,:,k) = W_cvx;
    end
end

%% -----------forecast-------------
subFCM_data = zeros(data_row,r);
membership_forecast = zeros(data_row,num_c, r);

figure; plot(data(:,1),'*-k'); hold on
for k=1:r
    membership_forecast(1,:,k) = U(1,:);
    for i=1:data_row-1
        membership_forecast(i+1,:,k)=sigmf(U(i,:)*weight_matrices(:,:,k),[lambda,b]);
    end
    subFCM_data(:,k) = fun_trim_rec(membership_forecast(:,:,k),center);
    plot(subFCM_data(:,k),'.-');
end
hold off
%--max min-----
sub_max = max(subFCM_data,[],2);
sub_min = min(subFCM_data,[],2);
figure; plot(data(:,1),'.-k'); hold on
plot(sub_max,'.-');
plot(sub_min,'.-'); hold off
maxmin_num = 0;
for i=1:data_row
    if data(i) == sub_min(i) || data(i) == sub_max(i)
        maxmin_num = maxmin_num+1;
    end
    if data(i) > sub_min(i) && data(i) < sub_max(i)
        maxmin_num = maxmin_num+1;
    end
end
maxmin_ratio = ( maxmin_num-2 ) / (data_row-2)
%% --------- agg -------------------------
average_weight = zeros(r,1)+ 1/r; % average weight

recError = zeros(r,1);%
allError = zeros(data_row, r);%
for j=1:r
    recError(j) = fun_RMSE(subFCM_data(:,j),data);
    for i=1:data_row
        allError(i,j) = fun_RMSE(subFCM_data(i,j),data(i));
    end
end
model_weight = (1./recError)./sum(1./recError);
all_weight = zeros(data_row, r);
for i=2:data_row
    all_weight(i,:) = (1./allError(i,:))./sum(1./allError(i,:));
end

% --max( abs(L-H)*sum(model_weight) )
weight_select = 3;
data_gra = zeros(data_row, 2);
data_gra(1,:) = [data(1) data(1)]; data_gra(2,:) = [data(2) data(2)];
data_best = zeros(data_row, 1);
data_best(1) = data(1); data_best(2) = data(2);
for i=3:data_row
    switch weight_select %
        case 3
            [low,up,best] = granularity_inclusion( subFCM_data(i,:), all_weight(i-1,:), allError(i-1,:), data(i-1,:) );%
        case 2
            [low,up,best] = granularity_RMSE( subFCM_data(i,:), model_weight, recError, data(i-1,:) ); %
        case 1
            [low,up,best] = granularity_ave( subFCM_data(i,:), average_weight, allError(i-1,:), data(i-1,:) );
    end
    
    data_gra(i,:) = [low,up];
    data_best(i) = best;
end
toc
% [low,up] = granularity( subFCM_data(2,:), model_weight );
%  anti-normalization
data_anti = mapminmax('reverse',data,PS);
data_gra(:,1) = mapminmax('reverse',data_gra(:,1),PS);
data_gra(:,2) = mapminmax('reverse',data_gra(:,2),PS);
data_best = mapminmax('reverse',data_best,PS);
center1 = mapminmax('reverse',center,PS)
%--------------------------------------------------
figure; plot(data_anti(:,1),'.-k'); hold on
plot(data_gra(:,1),'.r-');
plot(data_gra(:,2),'.g-');
plot(data_best(:,1),'.b-');
hold off

% 
flag_num = 0;
for i=1:data_row
    if data_anti(i) == data_gra(i,1) || data_anti(i) == data_gra(i,2)
        flag_num = flag_num+1;
    end
    if data_anti(i) > data_gra(i,1) && data_anti(i) < data_gra(i,2)
        flag_num = flag_num+1;
    end
end
inclusion_ratio = (flag_num-2) / (data_row-2); %PICP
PICP = inclusion_ratio;
R = max(data_anti)-min(data_anti);
PINAW = sum( data_gra(:,2)-data_gra(:,1) )/(data_row*R);
CWC = PINAW*(1 + PICP*exp(-PICP));

subDataRecRMSE =fun_RMSE(data_best,data_anti);       % ѵRMSE
disp(['subDataRecRMSE: ',num2str(subDataRecRMSE)]);
index = [PICP PINAW CWC subDataRecRMSE]

% index_test-----------------------------
flag_t = 0;
for i= train_row+1 : data_row
    if data_anti(i) == data_gra(i,1) || data_anti(i) == data_gra(i,2)
        flag_t  = flag_t +1;
    end
    if data_anti(i) > data_gra(i,1) && data_anti(i) < data_gra(i,2)
        flag_t  = flag_t +1;
    end
end
inclusion_test = flag_t / test_row; %PICP
PICP1 = inclusion_test;
%R1 = max( data_anti(train_row+1 : data_row) )-min( data_anti(train_row+1 : data_row) );
PINAW1 = sum( data_gra(train_row+1:data_row,2)-data_gra(train_row+1:data_row,1) )/( test_row*R );
CWC1 = PINAW1*(1 + PICP1*exp(-PICP1));

testRMSE =fun_RMSE(data_best(train_row+1 : data_row),data_anti(train_row+1 : data_row));   % 
index_test = [PICP1 PINAW1 CWC1 testRMSE]

%
y=[0.25 0.5 0.25];
y1 = mapminmax('reverse',y,PS);
basevalue = min(data_anti);
%y_intval = max(data_anti)-min(data_anti);
y1(2:3)=y1(2:3)-basevalue;
y2 =  repmat( y1 ,data_row , 1 );

figure;
h = area(train_row+1:data_row,y2(train_row+1:data_row,:),basevalue,'LineStyle',':');
legend({'Low','Medium','High'})
hold on
plot(train_row+1:data_row, data_anti(train_row+1:data_row,1),'.-k');
plot(train_row+1:data_row, data_gra(train_row+1:data_row,1),'.r-');
plot(train_row+1:data_row, data_gra(train_row+1:data_row,2),'.g-');
plot(train_row+1:data_row, data_best(train_row+1:data_row,1),'.b-');
xlim([train_row+1 data_row]);
hold off

h(1).FaceColor = [211 211 211]./255;% xiao
h(2).FaceColor = [254 254 254]./255;
h(3).FaceColor = [255 250 205]./255;
%
figure;
h1 = area(train_row+1:data_row,y2(train_row+1:data_row,:),basevalue,'LineStyle',':');

hold on
plot(train_row+1:data_row, data_anti(train_row+1:data_row,1),'-k');
plot(train_row+1:data_row, data_best(train_row+1:data_row,1),'-r');
legend({'Low','Medium','High','Actual','Predicted'})
% 
x_line = train_row+1:data_row;
y_up = data_gra(train_row+1:data_row,1)';
y_low = data_gra(train_row+1:data_row,2)';
yForFill=[y_up,fliplr(y_low)];
xForFill=[x_line,fliplr(x_line)];
% fill(xForFill,yForFill,'c','FaceAlpha',0.5,'EdgeAlpha',1,'EdgeColor','c');
fill(xForFill,yForFill,'c','FaceAlpha',0.3,'EdgeAlpha',0.5,'EdgeColor','c');
xlim([train_row+1 data_row]);
hold off
h1(1).FaceColor = [211 211 211]./255;%cyan
h1(2).FaceColor = [254 254 254]./255;
h1(3).FaceColor = [255 250 205]./255;

figure;
h2 = area(1:data_row,y2(1:data_row,:),basevalue,'LineStyle',':');

hold on
plot(1:data_row, data_anti(1:data_row,1),'-k');
plot(train_row+1:data_row, data_best(train_row+1:data_row,1),'-r');
legend({ 'Low','Medium','High','Actual','Predicted'})
 
x_line = train_row+1:data_row;
y_up = data_gra(train_row+1:data_row,1)';
y_low = data_gra(train_row+1:data_row,2)';
yForFill=[y_up,fliplr(y_low)];
xForFill=[x_line,fliplr(x_line)];
 
% fill(xForFill,yForFill,'c','FaceAlpha',0.5,'EdgeAlpha',1,'EdgeColor','c');
fill(xForFill,yForFill,'c','FaceAlpha',0.3,'EdgeAlpha',0.5,'EdgeColor','c');
xlim([1 data_row]);
hold off
h2(1).FaceColor = [211 211 211]./255;%cyan
h2(2).FaceColor = [254 254 254]./255;
h2(3).FaceColor = [255 250 205]./255;

